package de.fitko.fitconnect.dependency;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

import java.util.Properties;

@Getter
@Setter
@ToString
public class ApplicationConfig {
    
    private String httpProxyHost;
    private Integer httpProxyPort;

    private String clientId;
    private String clientSecret;
    private String privateKey;

    private Environments environments;

    private String activeEnvironment;

    public Environment getActiveEnvironment() {
        switch (activeEnvironment) {
            case "PROD":
                return environments.prod;
            case "TEST":
                return environments.test;
            default:
                return environments.dev;
        }
    }

    public Properties getAsProperties() {
        final var props = new Properties();
        props.put("httpProxyHost", getHttpProxyHost());
        props.put("httpProxyPort", getHttpProxyPort());
        props.put("clientId", clientId);
        props.put("clientSecret", clientSecret);
        props.put("privateKey", privateKey);
        //props.put("environment", getActiveEnvironment(mode, environments));
        return props;
    }


    @Getter
    @Setter
    @ToString
    @NoArgsConstructor
    static public class Environments {
        private Environment dev;
        private Environment prod;
        private Environment test;
    }

    @Getter
    @Setter
    @ToString
    @NoArgsConstructor
    static public class Environment {
        private String authTokenUrl;
    }
}

